/************************************************************
 * Board Display Routines
 * Kenrick Mock 8/11/03
 ************************************************************/

#include <stdio.h>
#include <string.h>
#include "board.h"
#include "globals.h"


/************************************************************
 * ShowBoard
 * Displays the board in beautiful ASCII.
 ************************************************************/
void ShowBoard(char board[XDIM][YDIM],piece_info pieces[])
{
 int i,j;
 char c;

 printf("   ");
 for (i=1; i<XDIM; i++) printf(" %2d",i);
 printf("\n");
 printf("   ");
 for (i=1; i<XDIM; i++) printf("---");
 printf("\n");
 for (j=1; j<YDIM; j++) {
   	printf("%2d ",j);
	for (i=1; i<XDIM; i++) {
		if ((i==9) && (j>8)) {
			if ((j%2)==0) printf("\\");
			else printf("/");
		}
		else printf("|");
		c = board[i][j];
		if (c==EMPTY) printf("  ");
		else if (c==WATER) printf("**");
		else if ((c>=0) && (c<=4)) {
			if (pieces[c].status == PRE_START) printf(" r");
			else printf(" R");
		}
		else if ((c>=5) && (c<=9)) {
			if (pieces[c].status == PRE_START) printf(" g");
			else printf(" G");
		}
	}
	printf("| %d\n",j);
 }
 printf("   ");
 for (i=1; i<XDIM; i++) printf("---");
 printf("\n");
}

/************************************************************
 * InitBoard
 * Initialize the board array.
 ************************************************************/
void InitBoard(char board[XDIM][YDIM], piece_info pieces[])
{
 int i,j;
 for (i=1; i<XDIM; i++) 
	for (j=1; j<YDIM; j++) 
		board[i][j]=EMPTY;
 for (i=7; i<=10; i++) {
	 board[i][7]=WATER;
	 board[i][8]=WATER;
 }
 for (i=0; i<10; i++) {
	 pieces[i].status = PRE_START;
	 pieces[i].nummoves = 0;
 }
}

