/****************************************************
 * Billabong Computer 2-player implementation
 *
 * Kenrick Mock 8/11/03
 * kenrick@uaa.alaska.edu
 *
 * I make no guarantee as to the non-existence of bugs
 * or game correctness in this program :)  It has been
 * created as a way for you to experiment with the
 * game and possibly use as a starting base to create
 * your own AI-game playing program.  Of course, you don't
 * have to use this code as the basis for your own
 * program.  In fact, there are many areas where
 * different data structures will decrease the amount
 * of computation necessary.
 *
 * The code is somewhat documented, but not completely.
 * Contact me if you have any questions.
 *
 * This is a C version of the program.
 * I recommend you write your
 * AI program in C or C++ for purposes of execution speed.
 *
 ****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "board.h"
#include "move.h"
#include "globals.h"


int main()
{
 char board[XDIM][YDIM];	/* Main Game Board */
 piece_info pieces[10];		/* Info about each piece */

 int x1,x2,y1,y2;		/* Holds move coordinates */
 char whoseturn='r';		/* Current player, red goes first */
 int val;
 int gameover=0;
 int turn=1;
 char s[100];
 move_struct ms;

 printf("\n\nWelcome to Computer Billabong v0.1.  This version supports Human vs. Human.\n");
 printf("For information on how to play, see the rules at\n");
 printf("http://www.math.uaa.alaska.edu/~afkjm/cs405/\n");
 printf("This program has not been vigorously debugged; use at your own risk!\n");
 printf("Please report any bugs you find to Kenrick.\n\n");
 printf("This code is intended for educational purposes only.  Billabong is\n");
 printf("manufactured and distributed by Franjos and was created by\n");
 printf("Eric Solomon.\n\n");
 InitBoard(board,pieces);

 printf("Press Enter to start\n");
 fgets(s,100,stdin);

 GetInitialPlacing(board,pieces);

 /**** TESTING - 
  * By commenting out the call to GetInitialPlacing,
  * can place pieces initially for testing purposes
  * without having to type in the positions each time
 pieces[0].curx=6; pieces[0].cury=1;
 pieces[1].curx=12; pieces[1].cury=4;
 pieces[2].curx=11; pieces[2].cury=9;
 pieces[3].curx=6; pieces[3].cury=8;
 pieces[4].curx=10; pieces[4].cury=9;
 pieces[5].curx=13; pieces[5].cury=7;
 pieces[6].curx=3; pieces[6].cury=3;
 pieces[7].curx=3; pieces[7].cury=5;
 pieces[8].curx=11; pieces[8].cury=6;
 pieces[9].curx=9; pieces[9].cury=11;
 pieces[0].status = BILLABONG;
 pieces[1].status = BILLABONG;
 pieces[2].status = BILLABONG;
 pieces[3].status = BILLABONG;
 pieces[4].status = PRE_START;
 pieces[5].status = BILLABONG;
 pieces[6].status = BILLABONG;
 pieces[7].status = BILLABONG;
 pieces[8].status = BILLABONG;
 pieces[9].status = PRE_START;
 board[6][1]=0;
 board[12][4]=1;
 board[11][9]=2;
 board[6][8]=3;
 board[10][9]=4;
 board[13][7]=5;
 board[3][3]=6;
 board[3][5]=7;
 board[11][6]=8;
 board[9][11]=9;
 */
 ShowBoard(board,pieces);

 while (!gameover)
 {
GetMove:
  if (whoseturn=='r') printf("Turn: %d.  Enter move, red:\n",turn);
  else printf("Turn: %d.  Enter move, green:\n",turn);

  fgets(s,100,stdin);
  s[strlen(s)-1]='\0';
  if (s[0]=='j') s[0]='J';
  if (s[0]=='w') s[0]='W';
  fflush(stdin); fflush(stdout);
  val = IsValid(board,pieces,whoseturn,s);
  if (val==0) {
	  printf("Invalid move.\n");
	  goto GetMove;		/* Just illustrating Goto statements :-) */
  }
  else {
	  printf("Move accepted.\n");
	  ApplyMove(board,pieces,s);
	  turn++;
  }
  ShowBoard(board,pieces);
  if (whoseturn=='r') whoseturn='g';
  else whoseturn='r';
  gameover = GameOver(pieces,1);
 }

 return 0;
}

