#ifndef __board_h__
#define __board_h__
#include "globals.h"

////////////////////////////////////////////////
// Class Definition
////////////////////////////////////////////////

class Board {
 public: 
	Board();
	// TODO: Should add a copy constructor here
	void ShowBoard();
	void GetInitialPlacing();
	int IsValid(char whoseturn, char *strMove);
	void ApplyMove(char *strMove);
	int GameOver(int verbose);

 private:
	int ValidJump(int srcx, int srcy, int pivotx, int pivoty, 
			int &newx, int &newy);
	int IsValidPlace(int x, int y);
	void ParseMove(char *s, move_struct *mptr);
	void InitBoard();
	int CrossLine(int x1, int y1, int x2, int y2);
	int SurroundsBillabong(piece_info p);
	int AddMove(piece_info *p, int newx, int newy);
	int CountCommas(char *s);
	int PointInPolygon(piece_info p, float f1, float f2);
	int CrossTop(int x1,int y1, int x2, int y2);

	char board[XDIM][YDIM];        /* Main Game Board */
	piece_info pieces[10];         /* Info about each piece */
};


#endif
