/****************************************************
 * Billabong Computer 2-player implementation
 *
 * Kenrick Mock 8/23/03
 * kenrick@uaa.alaska.edu
 *
 * I make no guarantee as to the non-existence of bugs
 * or game correctness in this program :)  It has been
 * created as a way for you to experiment with the
 * game and possibly use as a starting base to create
 * your own AI-game playing program.  Of course, you don't
 * have to use this code as the basis for your own
 * program.  In fact, there are many areas where
 * different data structures will decrease the amount
 * of computation necessary.
 *
 * The code is somewhat documented, but not completely.
 * Contact me if you have any questions.
 *
 * This is a C++ version of the program.  It is based
 * on a C version, so it is not particularly object-oriented
 * (e.g. there could be classes for each piece, move, etc.)
 *
 * I recommend you write your
 * AI program in C or C++ for purposes of execution speed.
 *
 ****************************************************/

#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <string.h>
#include "board.h"
#include "globals.h"
using namespace std;

int main()
{
 Board b;			/* Main Game Board; invokes constructor */

 int x1,x2,y1,y2;		/* Holds move coordinates */
 char whoseturn='r';		/* Current player, red goes first */
 int val;
 int gameover=0;
 int turn=1;
 char s[100];

 cout << "\n\nWelcome to Computer Billabong v0.1.  This version supports Human vs. Human.\n";
 cout << "For information on how to play, see the rules at\n";
 cout << "http://www.math.uaa.alaska.edu/~afkjm/cs405/\n";
 cout << "This program has not been vigorously debugged; use at your own risk!\n";
 cout << "Please report any bugs you find to Kenrick.\n\n";
 cout << "This code is intended for educational purposes only.  Billabong is\n";
 cout << "manufactured and distributed by Franjos and was created by\n";
 cout << "Eric Solomon.\n\n";

 cout << "Press Enter to start\n";
 fgets(s,100,stdin);

 b.GetInitialPlacing();
 fflush(stdin); fflush(stdout);

 /**** TESTING - 
  * By commenting out the call to GetInitialPlacing,
  * can place pieces initially for testing purposes
  * without having to type in the positions each time
  * - also need to make board, pieces variables as public
 b.pieces[0].curx=6; b.pieces[0].cury=1;
 b.pieces[1].curx=12; b.pieces[1].cury=4;
 b.pieces[2].curx=11; b.pieces[2].cury=9;
 b.pieces[3].curx=6; b.pieces[3].cury=8;
 b.pieces[4].curx=10; b.pieces[4].cury=9;
 b.pieces[5].curx=13; b.pieces[5].cury=7;
 b.pieces[6].curx=3; b.pieces[6].cury=3;
 b.pieces[7].curx=3; b.pieces[7].cury=5;
 b.pieces[8].curx=11; b.pieces[8].cury=6;
 b.pieces[9].curx=9; b.pieces[9].cury=11;
 b.pieces[0].status = BILLABONG;
 b.pieces[1].status = BILLABONG;
 b.pieces[2].status = BILLABONG;
 b.pieces[3].status = BILLABONG;
 b.pieces[4].status = PRE_START;
 b.pieces[5].status = BILLABONG;
 b.pieces[6].status = BILLABONG;
 b.pieces[7].status = BILLABONG;
 b.pieces[8].status = BILLABONG;
 b.pieces[9].status = PRE_START;
 b.board[6][1]=0;
 b.board[12][4]=1;
 b.board[11][9]=2;
 b.board[6][8]=3;
 b.board[10][9]=4;
 b.board[13][7]=5;
 b.board[3][3]=6;
 b.board[3][5]=7;
 b.board[11][6]=8;
 b.board[9][11]=9;
 */
 b.ShowBoard();

 while (!gameover)
 {
GetMove:
  if (whoseturn=='r') cout << "Turn: " << turn << ".  Enter move, red:\n";
  else cout << "Turn: " << turn << ".  Enter move, green:\n";

  fgets(s,100,stdin);
  s[strlen(s)-1]='\0';		/* Remove trailing carriage return */
  if (s[0]=='j') s[0]='J';	/* Convert move to uppercase if lower case */
  if (s[0]=='w') s[0]='W';
  fflush(stdin); fflush(stdout);
  val = b.IsValid(whoseturn,s);
  if (val==0) {
	  cout << "Invalid move.\n";
	  goto GetMove;		/* Just illustrating Goto statements :-) */
  }
  else {
	  cout << "Move accepted.\n";
	  b.ApplyMove(s);
	  turn++;
  }
  b.ShowBoard();
  if (whoseturn=='r') whoseturn='g';
  else whoseturn='r';
  gameover = b.GameOver(1);
 }

 return 0;
}

